#ifndef __ADRV_H__
#define __ADRV_H__
#ifdef __cplusplus
extern "C" {
#endif

#include "../libgba/gba.h"


//---------------------------------------------------------------------------
#define ACRV_INTERUPT_TIMER			(65535-950)	// 荞݃^C~O
												// ߂ɂĂ܂B{1097

#define ACRV_MAX_SCALE_CNT			12
#define ACRV_MAX_TRACK_CNT			4
#define ACRV_NO_DATA				0x0000


enum {
	C2 = 0,
	Cs2,
	D2,
	Ds2,
	E2,
	F2,
	Fs2,
	G2,
	Gs2,
	A2,
	As2,
	B2,
	C3,
	Cs3,
	D3,
	Ds3,
	E3,
	F3,
	Fs3,
	G3,
	Gs3,
	A3,
	As3,
	B3,
	C4,
	Cs4,
	D4,
	Ds4,
	E4,
	F4,
	Fs4,
	G4,
	Gs4,
	A4,
	As4,
	B4,
	C5,
	Cs5,
	D5,
	Ds5,
	E5,
	F5,
	Fs5,
	G5,
	Gs5,
	A5,
	As5,
	B5,
	C6,
	Cs6,
	D6,
	Ds6,
	E6,
	F6,
	Fs6,
	G6,
	Gs6,
	A6,
	As6,
	B6,
	C7,
	Cs7,
	D7,
	Ds7,
	E7,
	F7,
	Fs7,
	G7,
	Gs7,
	A7,
	As7,
	B7	,			// 
	CMD_DUMMY,		// _~[
	CMD_R,			// x
	CMD_Q,			// Q[g
	CMD_P,			// p|bg
	CMD_W,			// f[eB
	CMD_S,			// Xebv^C
	CMD_D,			// f`[(g炵)
	CMD_ECHO,		// GR[
	CMD_ECHOVOL,	// GR[{E
	CMD_AND,		// ^C
	CMD_TAI,		// ^C
	CMD_LOOPBEGIN,	// [vJn
	CMD_LOOPEND,	// [vI
	CMD_VOLUME,		// 
	CMD_TONE,		// F
	CMD_TRACKLOOP,	// gbN擪ɖ߂
	CMD_TRACKEND,	// gbNI

	CMD_MATUYOSI_SW,		// XB[v(ch1 only)
	CMD_MATUYOSI_PL,		// p^[EOX(all channel)
	CMD_MATUYOSI_EV,		// Gx[v(ch1,ch2 only)
	CMD_MATUYOSI_VL,		// {[(ch3 only)
	CMD_MATUYOSI_SP,		// ĐXs[h

	CMD_DUMMY_END,
};


//---------------------------------------------------------------------------
// yf[^̃wb_
typedef struct {
	char id[8];				// 'ANDRIVER'
	u16  offset[4];			// egbN̐擪̈ʒu,0̏ꍇɂ́ÃgbNgp

} __PACKED ST_AC_HEADER;


// gbÑXe[^X
typedef struct {
	// GBA
	u8  sweepShift;			// XEB[v̗  i0-7j
	u8  sweepDir;			// XEB[v̕i0=Inc, 1=Decj
	u8  sweepTime;			// XEB[v̎ԁi0-7j
	u8  duty;				// f[eB[i0-3j
	u8  envelopStep;		// Gx[v̌i0-7j
	u8  envelopDir;			// Gx[v̕i0=Dec, 1=Incj
	u8  envelopVol;			// Gx[ṽ{[i0-15j
	u16 freq;				// gi0: xj

	// MML
	bool isUse;				// gp̗L
	u8*  pTop;				// 擪ʒu
	u8*  pCur;				// ƈʒu

	bool isAnd;				// Ah
	bool isPan;				// p
	u8   pan;
	u8   gate;				// Q[g
	u8   gateWork;
	u8   echo;				// GR[
	u8   echoWork;
	u8   echoVol;
	s8   detune;			// f`[
	u8   note;				// 
	u16  length;			// i^C}荞ݖj

	// ONE ǉ
	u8   sp;

} ST_ADRV_STATUS;


// ehCõXe[^X
typedef struct {
	bool isUse;
	ST_ADRV_STATUS status[4];

} ST_ADRV;


//---------------------------------------------------------------------------
EWRAM_CODE void AdrvInit();
EWRAM_CODE void AdrvSetData(u8* pData);

IWRAM_CODE void AdrvPlay();
IWRAM_CODE void AdrvStop();

IWRAM_CODE void AdrvExec(u16 num);
IWRAM_CODE void AdrvExecCh1();
IWRAM_CODE void AdrvExecCh2();
IWRAM_CODE void AdrvExecCh3();
IWRAM_CODE void AdrvExecCh4();
IWRAM_CODE void AdrvExecPan(u16 num);


IWRAM_CODE void AdrvIntr();
IWRAM_CODE void AdrvIntrSub();

IWRAM_CODE void AdrvNextCmd(u16 num);

IWRAM_CODE void AdrvDebug(u16 num);


#ifdef __cplusplus
}
#endif
#endif
