#include "fade.h"


//---------------------------------------------------------------------------
ST_FADE Fade;


//---------------------------------------------------------------------------
EWRAM_CODE void FadeInit()
{
	_Memset(&Fade, 0x00, sizeof(ST_FADE));
	FadeSetParam(0, 16, 0);
}
//---------------------------------------------------------------------------
EWRAM_CODE void FadeSetParam(s16 min, s16 max, s16 wait)
{
	Fade.isEnd   = TRUE;
	Fade.cnt     = 0;
	Fade.min     = min;
	Fade.max     = max;
	Fade.wait    = wait;
	Fade.waitCnt = 0;

	REG_BLDCNT = BLEND_MODE_DARK | BLEND_TOP_BD | BLEND_TOP_BG1 | BLEND_TOP_BG2 | BLEND_TOP_OBJ;
	REG_BLDY   = 0;
}
//---------------------------------------------------------------------------
EWRAM_CODE void FadeSetIn()
{
	Fade.cnt   = Fade.min;
	Fade.isEnd = FALSE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void FadeSetOut()
{
	Fade.cnt   = Fade.max;
	Fade.isEnd = FALSE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void FadeIn()
{
	if(Fade.waitCnt++ < Fade.wait)
	{
		return;
	}
	Fade.waitCnt = 0;


	if(Fade.cnt >= Fade.max)
	{
		Fade.isEnd = TRUE;
		return;
	}
	REG_BLDY = Fade.cnt++;
}
//---------------------------------------------------------------------------
EWRAM_CODE void FadeOut()
{
	if(Fade.waitCnt++ < Fade.wait)
	{
		return;
	}
	Fade.waitCnt = 0;


	if(Fade.cnt <= Fade.min)
	{
		Fade.isEnd = TRUE;
		return;
	}
	REG_BLDY = Fade.cnt--;
}
//---------------------------------------------------------------------------
EWRAM_CODE void FadeClear()
{
	// wiȂɂȂɎgp܂
	REG_BLDY = 0;
}
//---------------------------------------------------------------------------
EWRAM_CODE void FadeDraw()
{
	if(Fade.isEnd == FALSE)
	{
		REG_BLDY = Fade.cnt;
	}
}
//---------------------------------------------------------------------------
EWRAM_CODE bool FadeIsEnd()
{
	return Fade.isEnd;
}
