#include "spr.h"
#include "dma_arm.h"


//---------------------------------------------------------------------------
ST_SPR_BUF SprBuf EWRAM_BSS ALIGN(4);


//---------------------------------------------------------------------------
EWRAM_CODE void SprInit()
{
	DmaExecFix2(&SprBuf, sizeof(ST_SPR_BUF));
	DmaExecFix2(OAM, sizeof(ST_SPRITE) * MAX_SPRITE_CNT);

	REG_DISPCNT |= (OBJ_ON | OBJ_2D_MAP);
}
//---------------------------------------------------------------------------
EWRAM_CODE void SprSetDat(u16* pTile, u32 tileSize, u16* pPal, u32 palSize)
{
	// BITMAP_OBJ_BASE_ADR
	// OBJ_BASE_ADR

	DmaEnqueue(pTile, OBJ_BASE_ADR, tileSize);
	DmaEnqueue(pPal, OBJ_COLORS, palSize);
}
//---------------------------------------------------------------------------
EWRAM_CODE void SprSetChr(u16 num, u16 x, u16 y, u16 tile)
{
	ST_SPRITE* pOam = (ST_SPRITE*)SprBuf.chr + num;

	pOam->attr0 = (y & 0x00ff) | ATTR0_COLOR_16 | ATTR0_SQUARE;
	pOam->attr1 = (x & 0x01ff) | ATTR1_SIZE_32;
	pOam->attr2 = (tile) | ATTR2_PRIORITY(0);

	SprBuf.isDraw = TRUE;
}
//---------------------------------------------------------------------------
EWRAM_CODE void SprSetCls()
{
	DmaExecFix2(&SprBuf, sizeof(ST_SPR_BUF));
	SprBuf.isDraw = TRUE;
}
//---------------------------------------------------------------------------
IWRAM_CODE void SprExec()
{
	if(SprBuf.isDraw == TRUE)
	{
		DmaEnqueue(SprBuf.chr, OAM, sizeof(ST_SPRITE) * MAX_SPRITE_CNT);
		SprBuf.isDraw = FALSE;
	}
}
