#include "manage.h"
#include "scr.h"
#include "libmy/fade.h"
#include "libmy/key.h"


//---------------------------------------------------------------------------
ST_MANAGE Manage;


//---------------------------------------------------------------------------
EWRAM_CODE void ManageInit()
{
	_Memset(&Manage, 0x00, sizeof(ST_MANAGE));

	Manage.stageNo = 1;
	ManageSetAct(MANAGE_TITLE);

	ScrInit();
}
//---------------------------------------------------------------------------
IWRAM_CODE void ManageSetAct(u16 act)
{
	Manage.act  = act;
	Manage.act2 = 0;
}
//---------------------------------------------------------------------------
IWRAM_CODE void ManageExec()
{
	switch(Manage.act)
	{
	case MANAGE_TITLE:
		ManageExecTitle();
		break;

	case MANAGE_SELECT:
		ManageExecSelect();
		break;

	case MANAGE_PLAY:
		ManageExecPlay();
		break;

	default:
		SystemError("[Err] ManageExec Manage.act=%d\n", Manage.act);
		break;
	}
}
//---------------------------------------------------------------------------
IWRAM_CODE void ManageExecTitle()
{
	switch(Manage.act2)
	{
	case 0:
		FadeSetOut();
		ScrDrawTitle();

		Manage.act2++;
		break;

	case 1:
		FadeOut();

		if(FadeIsEnd() == TRUE)
		{
			Manage.act2++;
		}
		break;

	case 2:
		if(KeyGetTrg() & KEY_A)
		{
			FadeSetIn();
			Manage.act2++;
		}
		break;

	case 3:
		FadeIn();

		if(FadeIsEnd() == TRUE)
		{
			Manage.act2++;
		}
		break;

	case 4:
		ScrDrawCls();
		ManageSetAct(MANAGE_SELECT);
		break;

	default:
		SystemError("[Err] ManageExecTitle Manage.act2=%d\n", Manage.act2);
		break;
	}
}
//---------------------------------------------------------------------------
IWRAM_CODE void ManageExecSelect()
{
	u16 trg = KeyGetTrg();
	u16 rep = KeyGetRep();

	switch(Manage.act2)
	{
	case 0:
		FadeSetOut();
		ScrDrawSelect();
		ScrDrawSelectNum(Manage.stageNo);

		Manage.act2++;
		break;

	case 1:
		FadeOut();

		if(FadeIsEnd() == TRUE)
		{
			Manage.act2++;
		}
		break;

	case 2:
		if((rep & KEY_LEFT) && (Manage.stageNo > 1))
		{
			Manage.stageNo--;
		}
		else if((rep & KEY_RIGHT) && (Manage.stageNo < ScrGetMaxStageCnt()))
		{
			Manage.stageNo++;
		}
		else if(trg & KEY_A)
		{
			FadeSetIn();
			Manage.act2++;
		}

		ScrDrawSelectNum(Manage.stageNo);
		break;

	case 3:
		FadeIn();

		if(FadeIsEnd() == TRUE)
		{
			Manage.act2++;
		}
		break;

	case 4:
		ScrDrawCls();
		ManageSetAct(MANAGE_PLAY);
		break;

	default:
		SystemError("[Err] ManageExecSelect Manage.act2=%d\n", Manage.act2);
		break;
	}
}
//---------------------------------------------------------------------------
IWRAM_CODE void ManageExecPlay()
{
	u16 trg = KeyGetTrg();
	u16 rep = KeyGetRep();

	switch(Manage.act2)
	{
	// iXe[Wf[^ǂݍ݁Aʕ\j
	case 0:
		FadeSetOut();

		ScrLoadMap(Manage.stageNo - 1);
		ScrLoadTile();
		ScrDrawStage();
		ScrDrawChr();

		Manage.act2++;
		break;

	// tF[hAEg
	case 1:
		FadeOut();

		if(FadeIsEnd() == TRUE)
		{
			Manage.act2++;
		}
		break;

	// L[͑ҋ@
	case 2:
		if(rep & DPAD)
		{
			if(ScrIsPlayerMove(rep) == TRUE)
			{
				ScrCalcMove(rep);
				ScrDrawStage();
				ScrDrawChr();

				Manage.act2++;
			}
		}
		else if(trg & KEY_B)
		{
			FadeSetIn();
			Manage.act2 = 9;
		}
		break;

	// ړ
	case 3:
		if(ScrIsMoveEnd() == TRUE)
		{
			ScrExecMove();
		}
		else
		{
			Manage.act2++;
			ScrDrawStage();
			ScrDrawChr();
		}
		break;

	// Q[NÃ`FbN
	case 4:
		if(ScrIsGameEnd() == TRUE)
		{
			Manage.act2++;
		}
		else
		{
			Manage.act2 = 2;
		}
		break;

	// Q[NÃtF[hC
	case 5:
		FadeSetIn();
		Manage.act2++;
		break;

	case 6:
		FadeIn();

		if(FadeIsEnd() == TRUE)
		{
			ScrDrawCls();
			ScrDrawGameClear();
			FadeSetOut();

			Manage.act2++;
		}
		break;

	case 7:
		FadeOut();

		if(FadeIsEnd() == TRUE)
		{
			Manage.act2++;
		}
		break;

	case 8:
		if(KeyGetTrg() & KEY_A)
		{
			FadeSetIn();
			Manage.act2++;
		}
		break;

	case 9:
		FadeIn();

		if(FadeIsEnd() == TRUE)
		{
			Manage.act2++;
		}
		break;

	// Xe[WI֑J
	case 10:
		ScrDrawCls();
		ManageSetAct(MANAGE_SELECT);
		break;

	default:
		SystemError("[Err] ManageExecSelect Manage.act2=%d\n", Manage.act2);
		break;
	}
}
