#ifndef __SCR_H__
#define __SCR_H__
#ifdef __cplusplus
extern "C" {
#endif


#include "libgba/gba.h"

//---------------------------------------------------------------------------
#define STAGE_MAX_CNT				3

#define STAGE_CHR_NONE				'-'
#define STAGE_CHR_WALL				'#'
#define STAGE_CHR_SPACE				' '			// 
#define STAGE_CHR_SPACE_ON			'.'			// uꏊ
#define STAGE_CHR_BLOCK				'o'			// ו
#define STAGE_CHR_BLOCK_ON			'O'			// uꏊ{ו
#define STAGE_CHR_PLAYER			'p'
#define STAGE_CHR_PLAYER_ON			'P'

enum {
	BG_ASCII = 0x01,
	BG_STAGE,
};


//---------------------------------------------------------------------------
typedef struct {
	u16   cnt;
	u16   cx;
	u16   cy;
	u16*  pMap;

	bool isMove;		// Xe[W̃XN[p
	s16  dirX;
	s16  dirY;
	u16  moveCnt;
	u16  moveChr;
	s16  hofs;
	s16  vofs;
} ST_STAGE;

typedef struct {
	char* pTxt;
} ST_STAGE_DB;

typedef struct {
	s16 x;
	s16 y;
	s16 sprX;
	s16 sprY;
} ST_PLAYER;


//---------------------------------------------------------------------------
EWRAM_CODE void ScrInit();
IWRAM_CODE void ScrExecMove();

IWRAM_CODE void ScrLoadMap(u16 mapNo);
EWRAM_CODE void ScrLoadTile();

EWRAM_CODE void ScrDrawTitle();
EWRAM_CODE void ScrDrawSelect();
EWRAM_CODE void ScrDrawSelectNum(u16 num);
EWRAM_CODE void ScrDrawGameClear();
EWRAM_CODE void ScrDrawCls();
IWRAM_CODE void ScrDrawStage();
IWRAM_CODE void ScrDrawChr();

IWRAM_CODE void ScrCalcMove(u16 key);
IWRAM_CODE void ScrCalcChrReverse(s16 x, s16 y);

EWRAM_CODE u16  ScrGetMaxStageCnt();
IWRAM_CODE u16  ScrGetChr(s16 x, s16 y);
IWRAM_CODE void ScrSetChr(s16 x, s16 y, u16 chr);
IWRAM_CODE void ScrSetPlayer(u16 idx);

IWRAM_CODE bool ScrIsPlayerMove(u16 key);
IWRAM_CODE bool ScrIsPlayerMove2(s16 x, s16 y);
EWRAM_CODE bool ScrIsMoveEnd();
IWRAM_CODE bool ScrIsGameEnd();

EWRAM_CODE void ScrDebugMap();


#ifdef __cplusplus
}
#endif
#endif
